import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;

import org.lekan.graphics.GraphicsProgram;




/**
 * Here's an intro/review to using Java, and an intro to using the SGGraphics package.
 * 
 * Your task: build a simple drawing program that does, at the minimum, the following:
 *  (1) Buttons that lets you choose whether to draw an ellipse, a rectangle, a line, a rounded line, or a quadratic curve
 *  (2) When the program first starts, the main canvas should display a nice welcoming message and/or graphics.
 *  (3) As soon as the user starts drawing, this welcome message should disappear
 *  (4) To draw, click and drag the mouse. The shape should display as you are dragging.
 *  (5) When released, the shape will stay on the screen.
 *  (6) A clear button will clear everything on the screen.
 * 
 * @KendrickJames
 *
 */
public class EPGYDraw extends GraphicsProgram {
	public static void main(String[] args) {
		new EPGYDraw();
	}
	
	int y = 15;
	int drawTool=0;
	int mouseOrigX;
	int mouseOrigY;
	int curX;
	int curY;
	int lastX;
	int lastY;
	
	/**
	 * Put any setup code here!
	 */
	@Override
	public void setup() {
		// TODO: SETUP!
		this.getFrame().setTitle("EPGYDraw!");
		this.addButton("Ellipse", NORTH);
		this.addButton("Rectangle", WEST);
		this.addButton("Line", SOUTH);
		this.addButton("Clear", EAST);
		//this.addButton("Quadratic Curve", NORTH);
	}
	
	/**
	 * Put your program run code here! Most of your code should be in here.
	 */
	@Override
	public void run() {
		// TODO: The main run of the program!
		this.getFrame().drawText("Welcome to the Jungle!!!", 10, 40);
	}
	
	public void  mouseReleased (MouseEvent e)
	{
		this.getFrame().setForegroundColor(Color.white);
		for(int x=0; x<5; x++)
			this.getFrame().drawText("Welcome to the Jungle!!!", 10, 40);
		this.getFrame().setForegroundColor(Color.black);
		
		curX=e.getX();
		curY=e.getY();
		
		switch (drawTool)
		{
		case 2 : this.getFrame().drawRect(mouseOrigX-70, mouseOrigY-52, curX-mouseOrigX, curY-mouseOrigY);break;    //draw Rectangle
		case 3 : this.getFrame().drawLine(mouseOrigX-70, mouseOrigY-52, curX-70, e.getY()-56);break;              //draw Line
		case 4 : this.getFrame().drawRoundedRect(mouseOrigX-70, mouseOrigY-56, curX-mouseOrigX, curY-mouseOrigY);break;   //draw rounded line
		case 5 : this.getFrame().drawQuadCurve(mouseOrigX-70, mouseOrigY-56, 150, 150, curX-70, curY-56);break;     //draw Quad curve
		}
	}
	
	public void mousePressed(MouseEvent e)
	{
		mouseOrigX=e.getX();
		mouseOrigY=e.getY();
	}
	
	public void mouseDragged(MouseEvent e) 
	{
		curX=e.getX();
		curY=e.getY();
				
		switch (drawTool)
		{
		//case 1 : this.getFrame().drawEllipse(mouseOrigX-30, mouseOrigY, e.getX()-mouseOrigX, e.getY()-mouseOrigY);break;   //draw ellipse
		case 2 : this.getFrame().drawRect(mouseOrigX-30, mouseOrigY, curX-mouseOrigX, curY-mouseOrigY);break;    //draw Rectangle
		case 3 : this.getFrame().drawLine(mouseOrigX-30, mouseOrigY, curX-30, e.getY()-15);break;              //draw Line
		case 4 : this.getFrame().drawRoundedRect(mouseOrigX-30, mouseOrigY, curX-mouseOrigX, curY-mouseOrigY);break;   //draw rounded line
		case 5 : this.getFrame().drawQuadCurve(mouseOrigX-30, mouseOrigY, 150, 150, curX, curY);break;     //draw Quad curve
		}
		
		lastX=curX;
		lastY=curY;
	}
	
	
	
	public void actionPerformed (ActionEvent e)
	{
		String command = e.getActionCommand();
				
		if(command.equals("Ellipse"))
			drawTool=1;
		if(command.equals("Rectangle"))
			drawTool=2;
		if(command.equals("Line"))
			drawTool=3;
		if(command.equals("Clear"))
			{
			this.getFrame().setBackgroundColor(Color.white);
			for (int x = 0; x<650;x++)
				this.getFrame().drawRect(0, 0, 650-x, 800-x);
			}
		if(command.equals("Quadratic Curve"))
			drawTool=5;			
	}
	
}